package PureMessage::Sophos::SAVI::AttachmentScan;

use strict;
use warnings;
use Sophos::SAVI qw(get_savi);
use PureMessage::Sophos::SAVI::AttachmentScan::Config qw(%attach_config);

use base qw(Exporter);
our @EXPORT_OK = qw(get_scanner);

sub get_scanner {
    my $callbacks = shift;
    my %opts = @_;
    
    my %conf = %{ $attach_config{backend}{Sophos} };
    %conf = (%conf, %opts);

    $conf{MaxRecursionDepth} = $attach_config{inspect_archives}{max_recursion_depth}
       if defined $attach_config{inspect_archives}{max_recursion_depth};
    $conf{WordText} = 1;

    my $scanner = get_savi(\%conf, notify => $callbacks)
        or die "cannot create Sophos::SAVI::Engine object";

    return $scanner;
}

1;
