package PureMessage::Sophos::SAVI::Utils;

use strict;
use warnings;

use base qw(Exporter);
our @EXPORT_OK = qw(set_savi_cantscan_errors);

sub set_savi_cantscan_errors {
        my $msg       = shift;
        my $part_id   = shift;
        my $sav_ids   = shift;
        my $has_error = 0;

        $msg->log('DEBUG', "set_savi_cantscan_errors: start");

        my $map = $msg->get_attr('cantscan_map');
        
        if(ref $map ne 'ARRAY') {
            # There isn't a cantscan_map available 
            $msg->log('DEBUG', "set_savi_cantscan_errors: no cantscan_map available in the msg object");
            return 0;
        }

        my $cantscan_map = $map->[0];

        # Check for any SAVI errors and store the found ones in the cantscan_map hash
        foreach (@$sav_ids) {
                $has_error++;
                push(@{$cantscan_map->{ids}}, {'sav_id' => $_, 'part_id' => "$part_id"} );
        }

        $msg->set_attr('cantscan_map', [$cantscan_map], 1);

        $msg->log('DEBUG', "set_savi_cantscan_errors: count=$has_error");

        return $has_error;
}


1;
